#pragma once

// #define DEBUG

const uint8_t MCP1_ADDRESS = 0x20;
const uint8_t MCP2_ADDRESS = 0x24;
const uint8_t MCP_IODIRA = 0x00;
const uint8_t MCP_IODIRB = 0x01;
const uint8_t MCP_GPPUA = 0x0C;
const uint8_t MCP_GPPUB = 0x0D;
const uint8_t MCP_GPIOA = 0x12;
const uint8_t MCP_GPIOB = 0x13;

// Benutzte Arduino-Pins
const uint8_t resetPin = A3;
// Standard SCL: A5 (PC5)
// Standard SDA: A4 (PC4)
// LED_BUILTIN D13 (PB5)

// Pins fr die emulierte I2C-Schnitstelle
const uint8_t softSDA = A0;
const uint8_t softSCL = A1;


#ifdef DEBUG
const uint8_t SoftUartRX = 4;
const uint8_t SoftUartTX = 5;
const long SoftUartBaud = 9600;

#include <UrsUtil.h>

#include <SoftwareSerial.h>
extern SoftwareSerial SeriallLogger;
inline void DebugPrintln() { SeriallLogger.println(); }
inline void DebugPrint(const char* t) { SeriallLogger.print(t); }
inline void DebugPrintln(const char* t) { SeriallLogger.println(t); }
inline void DebugPrint(const char t) { SeriallLogger.print(t); }
inline void DebugPrintln(const char t) { SeriallLogger.println(t); }
inline void DebugPrint(const String t) { SeriallLogger.print(t); }
inline void DebugPrintln(const String t) { SeriallLogger.println(t); }
inline void DebugPrint(const int t) { SeriallLogger.print(t); }
inline void DebugPrintln(const int t) { SeriallLogger.println(t); }
inline void DebugPrintHex(const int t) { SeriallLogger.print(t, 16); }
inline void DebugPrintHexln(const int t) { SeriallLogger.println(t, 16); }

inline void DebugVar(const char* s, const int t) { SeriallLogger.print(s); SeriallLogger.println(t); }
inline void DebugVarHex(const char* s, const int t) { SeriallLogger.print(s); SeriallLogger.println(t, 16); }

#else
// Die Dummy-Methoden optimiert der Compiler heraus
inline void DebugPrintln() { }
inline void DebugPrint(const char* t) {}
inline void DebugPrintln(const char* t) {}
inline void DebugPrint(const char t) {}
inline void DebugPrintln(const char t) {}
inline void DebugPrint(const String t) { }
inline void DebugPrintln(const String t) {}
inline void DebugPrint(int t) {}
inline void DebugPrintln(int t) {}
inline void DebugPrintHex(int t) {}
inline void DebugPrintHexln(int t) {}

inline void DebugVar(const char* s, const int t) { }
inline void DebugVarHex(const char* s, const int t) {}

#endif // DEBUG