﻿namespace IC_DB
{
   /// <summary>
   /// Liste aus Byte-Arrays zur Übertragung per I²C.
   /// </summary>
   public class I2cData : List<Byte[]>
   {
      /// <summary>
      /// Initialisiert eine neue Instanz der <see cref="I2cData"/>-Klasse.
      /// </summary>
      public I2cData() { }

      /// <summary>
      /// Erstellt eine tiefe Kopie des Objekts.
      /// </summary>
      /// <returns>Eine Kopie des Objekts.</returns>
      public I2cData DeepCopy()
      {
         var other = new I2cData();
         for (int i = 0; i < Count; i++)
         {
            other.Add(this[i]);
         }

         return other;
      }
   }
}
